//BOI 2012 - Melody Checker
//Takes 3 arguments: input file name, output file name and one of the correct answers file name (provided in tests).
//Returns 0 if output is OK and 1 otherwise. Might print a detailed message if an output is not correct.

#include <cstdio>
#include <cstring>
#include <cstdlib>
#define MAXN 105
#define MAXL 100005
#define MAXLEN 2000005

static char s[MAXLEN];

FILE *fo = NULL;

int ReadAns () //-1: incorrect, x: a number
{
	char *stat = fgets(s, MAXLEN, fo);
	if (stat == NULL) return -1;
	int len = strlen(s);
	if (len >= MAXLEN)
	{
		return -1;
	}
	int i;
	for (i = 0; i < len; i++)
	{
		if (s[i] < 32) s[i] = ' ';
		if (!((s[i] == ' ') || ((s[i] >= '0') && (s[i] <= '9')))) return -1;
	}
	int st = 0;
	while ((st < len) && (s[st] == ' ')) st++;
	if (st >= len) return -1;
	int num = 0;
	int numc = 0;
	char zerofirst = 0;
	if (s[st] == '0') zerofirst = 1;
	while ((st < len) && (s[st] >= '0') && (s[st] <= '9'))
	{
		numc++;
		if (numc == 10)
		{
			return -1;
		}
		num = num * 10 + (int)(s[st] - '0');
		st++;
	}
	while (st < len)
	{
		if (s[st] != ' ') return -1;
		st++;
	}
	if ((zerofirst) && (numc > 1)) return -1;
	return num;
}

int main (int argc, char **argv)
{
	if (argc != 4)
	{
		printf("Incorrect usage of checker");
		return 1;
	}
	FILE *fi=NULL, *fa=NULL;
	fi = fopen(argv[1],"r");
	if(!fi)
	{
		printf("Can't open input file");
		return 1;
	}
	fo = fopen(argv[2],"r");
	if(!fo)
	{
		printf("No output");
		return 1;
	}
	fa = fopen(argv[3],"r");
	if(!fa)
	{
		printf("Can't open answer file");
		return 1;
	}
	int N, S, G;
	fscanf(fi,"%d %d %d\n",&N,&S,&G);
	static char data_notes[MAXN][MAXN];
	int i, j, k, cnt;
	for (i = 0; i < N; i++) fscanf(fi,"%s\n",data_notes[i]);
	static char can_go[MAXN][MAXN];
	for (i = 0; i < N; i++)
	{
		for (j = i; j < N; j++)
		{
			cnt = 0;
			for (k = 0; k < S; k++)
			{
				if (data_notes[i][k] != data_notes[j][k]) cnt++;
			}
			if (cnt <= G)
			{
				can_go[i][j] = 1;
				can_go[j][i] = 1;
			}
		}
	}
	int L;
	fscanf(fi,"%d",&L);
	static int data[MAXL];
	for (i = 0; i < L; i++) fscanf(fi,"%d",&(data[i]));
	int cor_num;
	int usr_num;
	fscanf(fa,"%d",&cor_num);
	usr_num = ReadAns();
	if (usr_num < 0)
	{
		printf("Incorrect answer");
		return 1;
	}
	static int path[MAXL];

	char *stat = fgets(s, MAXLEN, fo);
	if (stat == NULL) return -1;
	int len = strlen(s);
	if (len >= MAXLEN)
	{
		return -1;
	}
	for (i = 0; i < len; i++)
	{
		if (s[i] < 32) s[i] = ' ';
		if (!((s[i] == ' ') || ((s[i] >= '0') && (s[i] <= '9'))))
		{
			printf("Incorrect tune format");
			return 1;
		}
	}
	int st = 0;

	int q;
	for (q = 0; q < L; q++)
	{
		while ((st < len) && (s[st] == ' ')) st++;
		if (st >= len)
		{
			printf("Incorrect tune format");
			printf(" %s",s);
			return 1;
		}
		int num = 0;
		int numc = 0;
		if (s[st] == '0')
		{
			printf("Incorrect tune format");
			return 1;
		}
		while ((st < len) && (s[st] >= '0') && (s[st] <= '9'))
		{
			numc++;
			if (numc == 10)
			{
				printf("Incorrect tune format");
				return 1;
			}
			num = num * 10 + (int)(s[st] - '0');
			st++;
		}
		if ((num >= 1) && (num <= N)) path[q] = num;
		else
		{
			printf("Incorrect tune format");
			return 1;
		}
	}
	while ((st < len) && (s[st] == ' ')) st++;
	if (st < len)
	{
		printf("Incorrect tune format");
		return 1;
	}

	fclose(fi);
	fclose(fo);
	fclose(fa);
	if (cor_num != usr_num)
	{
		printf("Incorrect answer");
		return 1;
	}
	cnt = L;
	for (i = 0; i < L; i++)
	{
		if (path[i] == data[i]) cnt--;
	}
	if (cnt != usr_num)
	{
		printf("Path has too many mistakes");
		return 1;
	}
	for (i = 1; i < L; i++)
	{
		if (!can_go[path[i-1]-1][path[i]-1])
		{
			printf("Incorrect transition (%d -> %d)",path[i-1],path[i]);
			return 1;
		}
	}
	return 0;
}
